<?php

namespace Teknisa\FIN\Modules\ContaPagar\Factory;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Financeiro\Entities\Contapagar;
use Teknisa\Model\Financeiro\Entities\Boletpagar;

class ControleTituloAlteradoFactory {

    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getContaPagar($nrorg, $cdfilial, $nrlanctonf, $nrseqvenpag, $nrparcelapag){
        $params = array();
        $params['nrorg']        = $nrorg;
        $params['cdfilial']     = $cdfilial;
        $params['nrlanctonf']   = $nrlanctonf;
        $params['nrseqvenpag']  = $nrseqvenpag;
        $params['nrparcelapag'] = $nrparcelapag;
        $contapagar = $this->entityManager->getRepository(Contapagar::class)->findOneBy($params);
        return $contapagar;
    }

    public function getBoletPagar($nrorg, $cdfilial, $nrlanbolpag){
        $params = array();
        $params['nrorg']        = $nrorg;
        $params['cdfilial']     = $cdfilial;
        $params['nrlanbolpag']   = $nrlanbolpag;
        $boletpagar = $this->entityManager->getRepository(Boletpagar::class)->findOneBy($params);
        return $boletpagar;
    }

    public function existeTituloPagar($cdfilial, $nrlanctonf, $nrseqvenpag, $nrparcelapag){
        $sql = <<<SQL
            SELECT NRCNT, NRDOC
              FROM (SELECT COUNT(*) NRCNT
                      FROM CONTAPAGAR
                     WHERE (CDFILIAL     = :CDFILIAL    ) AND
                           (NRLANCTONF   = :NRLANCTONF  ) AND
                           (NRSEQVENPAG  = :NRSEQVENPAG ) AND
                           (NRPARCELAPAG = :NRPARCELAPAG)) A,
                   (SELECT COUNT(*) NRDOC
                      FROM CONTAPAGAR
                     WHERE (CDFILIAL    = :CDFILIAL   ) AND
                           (NRLANCTONF  = :NRLANCTONF ) AND
                           (NRSEQVENPAG = :NRSEQVENPAG)) B
SQL;
        $params = array(
            'cdfilial'      => $cdfilial,
            'nrlanctonf'    => $nrlanctonf,
            'nrseqvenpag'   => $nrseqvenpag,
            'nrparcelapag'  => $nrparcelapag
        );
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
    }
}