<?php
/**
 * Created by JetBrains PhpStorm.
 * User: alessandrobartel
 * Date: 02/07/12
 * Time: 11:49
 * To change this template use File | Settings | File Templates.
 */
 
class RegistroFeriasHomolognet extends RegistroHomolognet{

    const PERIODO_AQUISITIVO = 'PeriodoAquisitivo';
    const DATA_INICIO = 'DTInicio';
    const DATA_FIM = 'DTFim';
    const QUITACAO = 'TPQuitacaoFerias';
    const FALTAS = 'NRFaltas';
    const FERIAS = 'Ferias';

    const MESES_FERIAS = 85;

    const SIM = '1';
    const NAO = '2';
    const GOZADO_INTEGRAL = 'GOZADO_INTEGRAL';

    private $_ferias;
    private $_dtAux;

    public function __construct(){
        $this->_dtAux= new TkDateTime();
    }

    public function geraRegistroFerias(){
        $this->_geraRegistro();
    }


    private function _geraRegistro(){

        parent::geraRegistro(null, null, null);

        $tag = self::PERIODO_AQUISITIVO;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);

        // Campo 50 - Tamanho 08 - Data de inicio do periodo aquisitivo
        $this->_atribuiDataInicio();

        // Campo 51 - Tamanho 08 - Data fim do periodo aquisitivo
        $this->_atribuiDataFim();

        // Campo 52 - Tamanho 01 - Indicador de pagamento das ferias (1 - SIM / 2 - NAO)
        $this->_atribuiQuitacaoFerias();

        // Campo 53 - Tamanho 03 - Quantidade de faltas
        $this->_atribuiFaltas();

        $tag = parent::CARACTER_FINALIZADOR;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, null, 0);


    }

    private function _atribuiDataInicio(){
        $dado = $this->_ferias->getDtiniaquisicao();
        if (empty($dado) === false){

            $this->_dtAux->set($dado);
            $dado = $this->_dtAux->toString(TkDateTime::YEAR.TkDateTime::MONTH.TkDateTime::DAY);

            $tag = self::DATA_INICIO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 8);
        }
    }


    private function _atribuiDataFim(){
        $dado = $this->_ferias->getDtfimaquisicao();
        if (empty($dado) === false){

            $this->_dtAux->set($dado);
            $dado = $this->_dtAux->toString(TkDateTime::YEAR.TkDateTime::MONTH.TkDateTime::DAY);

            $tag = self::DATA_FIM.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 8);
        }
    }


    private function _atribuiQuitacaoFerias(){
        $dado = $this->_ferias->getIdcontrolferias();
        if (empty($dado) === false){

            if ($dado === self::GOZADO_INTEGRAL) {
                $dado = self::SIM;
            } else {
                $dado = self::NAO;
            }

            $tag = self::QUITACAO.parent::CARACTER_ATRIBUI;
            $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 1);
        }
    }


    private function _atribuiFaltas(){

        $dado = $this->_ferias->getQtfaltasperiodo();

        if (empty($dado) !== false){
            $dado = '000';
        }

        $tag = self::FALTAS.parent::CARACTER_ATRIBUI;
        $this->atribuiDadoXML($tag, parent::CARACTER_SEPARADOR, $dado, 3);

    }

    public function setFerias($ferias) {
        $this->_ferias = $ferias;
    }



}
