/******************************************************************************/
/* TEKNISA                                                                    */
/******************************************************************************/
/*                                                                            */
/* NOME: GRAVA_LOGAUTOFORNE                                                      */
/*                                                                            */
/* DESCRIO:                                                                 */
/*   Grava log de AUTOFORNE                                                   */
/*                                                                            */
/* CRIAO:                                                                   */
/* 18/02/2004 - Luiz Otvio de Souza                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'GRAVA_LOGAUTOFORNE'  and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
  DROP TRIGGER GRAVA_LOGAUTOFORNE
  GO

CREATE TRIGGER GRAVA_LOGAUTOFORNE
ON AUTOFORNE
FOR INSERT, UPDATE, DELETE

AS

DECLARE @V_IDGRAVLOGAF VARCHAR(03);
DECLARE @V_DSRDMUSULAF  VARCHAR(50);
DECLARE @V_DSENDUSULAF  VARCHAR(50);
DECLARE @V_DSNMUSULAF   VARCHAR(50);
DECLARE @V_DSMETUSULAF  VARCHAR(250);
DECLARE @V_CDOPERLOGAF  VARCHAR(12);

/* Variveis do cursor */
DECLARE @V_IDCOMANDO         VARCHAR(1);
DECLARE @V_CDFILDEST         VARCHAR(4);
DECLARE @V_CDFILLANC         VARCHAR(4);
DECLARE @V_NRAUTOFORN        VARCHAR(10);
DECLARE @V_VRTOTALAF         DOUBLE PRECISION;
DECLARE @V_OLD_IDSITUATUAAF  VARCHAR(1);
DECLARE @V_NEW_IDSITUATUAAF  VARCHAR(1);
DECLARE @V_OLD_IDAFFORALIM   VARCHAR(1);
DECLARE @V_NEW_IDAFFORALIM   VARCHAR(1);
DECLARE @V_OLD_IDBAIXAAF     VARCHAR(1);
DECLARE @V_NEW_IDBAIXAAF     VARCHAR(1);
DECLARE @V_OLD_CDFORMPGTO    VARCHAR(2);
DECLARE @V_NEW_CDFORMPGTO    VARCHAR(2);
DECLARE @V_OLD_DSINCONSAF    VARCHAR(2000);
DECLARE @V_NEW_DSINCONSAF    VARCHAR(2000);

BEGIN

   DECLARE C_DADOS CURSOR FOR
     SELECT
       'D' IDCOMANDO,
       CDFILDEST,
       CDFILLANC,
       NRAUTOFORN,
       VRTOTALAF,
       IDSITUATUAAF,
       IDSITUATUAAF,
       IDAFFORALIM,
       IDAFFORALIM,
       IDBAIXAAF,
       IDBAIXAAF,
       CDFORMPGTO,
       CDFORMPGTO
       /*  DSINCONSAF, Cannot use text, ntext, or image columns in the 'inserted' and 'deleted' tables.*/
       /*  DSINCONSAF  Cannot use text, ntext, or image columns in the 'inserted' and 'deleted' tables.*/
     FROM
       DELETED
     WHERE
       0 = (SELECT COUNT(*) FROM INSERTED)

     UNION ALL

     SELECT
       'U' IDCOMANDO,
       INSERTED.CDFILDEST,
       INSERTED.CDFILLANC,
       INSERTED.NRAUTOFORN,
       INSERTED.VRTOTALAF,
       DELETED.IDSITUATUAAF,
       INSERTED.IDSITUATUAAF,
       DELETED.IDAFFORALIM,
       INSERTED.IDAFFORALIM,
       DELETED.IDBAIXAAF,
       INSERTED.IDBAIXAAF,
       DELETED.CDFORMPGTO,
       INSERTED.CDFORMPGTO
       /* DELETED.DSINCONSAF  Cannot use text, ntext, or image columns in the 'inserted' and 'deleted' tables. */
       /* INSERTED.DSINCONSAF  Cannot use text, ntext, or image columns in the 'inserted' and 'deleted' tables.*/
     FROM
       INSERTED,
       DELETED
     WHERE
       INSERTED.CDFILDEST  = DELETED.CDFILDEST  AND
       INSERTED.CDFILLANC  = DELETED.CDFILLANC  AND
       INSERTED.NRAUTOFORN = DELETED.NRAUTOFORN

     UNION ALL

     SELECT
       'I' IDCOMANDO,
       CDFILDEST,
       CDFILLANC,
       NRAUTOFORN,
       VRTOTALAF,
       IDSITUATUAAF,
       IDSITUATUAAF,
       IDAFFORALIM,
       IDAFFORALIM,
       IDBAIXAAF,
       IDBAIXAAF,
       CDFORMPGTO,
       CDFORMPGTO
       /* DSINCONSAF  Cannot use text, ntext, or image columns in the 'inserted' and 'deleted' tables.*/
       /* DSINCONSAF  Cannot use text, ntext, or image columns in the 'inserted' and 'deleted' tables.*/
     FROM
       INSERTED
     WHERE
       0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_DADOS;
   FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                @V_CDFILDEST,
                                @V_CDFILLANC,
                                @V_NRAUTOFORN,
                                @V_VRTOTALAF,
                                @V_OLD_IDSITUATUAAF,
                                @V_NEW_IDSITUATUAAF,
                                @V_OLD_IDAFFORALIM,
                                @V_NEW_IDAFFORALIM,
                                @V_OLD_IDBAIXAAF,
                                @V_NEW_IDBAIXAAF,
                                @V_OLD_CDFORMPGTO,
                                @V_NEW_CDFORMPGTO;

   WHILE (@@FETCH_STATUS = 0) BEGIN

      SET @V_IDGRAVLOGAF = 'SSS';
      SELECT @V_IDGRAVLOGAF = ISNULL(MAX(IDGRAVLOGAF), 'SSS')
      FROM PARASUPRI
      WHERE (CDFILIAL = (SELECT ISNULL(CDFILCENTCMP, CDFILIAL)
                         FROM FILIAL
                         WHERE (CDFILIAL = @V_CDFILDEST)));
      /*SET @V_DSRDMUSULAF = 'VIA BD';
      SET @V_DSENDUSULAF = 'VIA BD';
      SET @V_DSNMUSULAF  = 'VIA BD';
      SET @V_DSMETUSULAF = 'VIA BD';
      SET @V_CDOPERLOGAF = 'VIA BD';
      SELECT @V_DSRDMUSULAF = ISNULL(MAX(DSSERVERRDM),  'VIA BD'),
             @V_DSENDUSULAF = ISNULL(MAX(DSREMOTEADDR), 'VIA BD'),
             @V_DSNMUSULAF  = ISNULL(MAX(DSREMOTEHOST), 'VIA BD'),
             @V_DSMETUSULAF = ISNULL(MAX(DSSERVMETHOD), 'VIA BD'),
             @V_CDOPERLOGAF = ISNULL(MAX(DSREMOTEOPER), 'VIA BD')
      FROM SQLWEBTUNNING
      WHERE NRAUDSID = @@SPID AND
            CONVERT(DATETIME, CONVERT(VARCHAR, DTSTARTDATE, 103))  =
                         (SELECT MAX(DTSTARTDATE)
                                  FROM SQLWEBTUNNING S
                                  WHERE S.NRAUDSID = @@SPID);*/
      EXEC WEBTUNNING @P_DSREMOTEADDR = @V_DSENDUSULAF OUTPUT,
                      @P_DSREMOTEHOST = @V_DSNMUSULAF  OUTPUT,
                      @P_DSSERVERRDM  = @V_DSRDMUSULAF OUTPUT,
                      @P_DSSERVMETHOD = @V_DSMETUSULAF OUTPUT,
                      @P_DSREMOTEOPER = @V_CDOPERLOGAF OUTPUT;

      IF @V_IDCOMANDO = 'I' /* INSERTING */ BEGIN

         IF SUBSTRING(@V_IDGRAVLOGAF, 1, 1) = 'S' BEGIN

            INSERT INTO LOGAUTOFORNE
            (CDFILDESLAF,  CDFILLANLAF,  NRAUTFORLAF,  VRTOTALAFANT, VRTOTALAFDEP, IDSITUAAFANT,
             IDSITUAAFDEP, IDAFFORLIANT, IDAFFORLIDEP, IDBAIXAAFANT, IDBAIXAAFDEP, CDFORMPGTANT,
             CDFORMPGTDEP, DSINCONAFANT, DSINCONAFDEP, IDOPERACLAF,  DSRDMUSULAF,  DSENDUSULAF,
             DSNMUSULAF,   DSMETUSULAF,  CDOPERLOGAF,  DTOPERALAF)
            VALUES
            (@V_CDFILDEST, @V_CDFILLANC, @V_NRAUTOFORN, 0, @V_VRTOTALAF, NULL,
             @V_NEW_IDSITUATUAAF, NULL, @V_NEW_IDAFFORALIM, NULL, @V_NEW_IDBAIXAAF, NULL,
             @V_NEW_CDFORMPGTO, NULL, @V_NEW_DSINCONSAF, 'I', @V_DSRDMUSULAF, @V_DSENDUSULAF,
             @V_DSNMUSULAF, @V_DSMETUSULAF, @V_CDOPERLOGAF, GETDATE());

         END;

      END;

      IF @V_IDCOMANDO = 'U' /* UPDATING */ BEGIN

         IF SUBSTRING(@V_IDGRAVLOGAF, 2, 1) = 'S' BEGIN

            INSERT INTO LOGAUTOFORNE
            (CDFILDESLAF,  CDFILLANLAF,  NRAUTFORLAF,  VRTOTALAFANT, VRTOTALAFDEP, IDSITUAAFANT,
             IDSITUAAFDEP, IDAFFORLIANT, IDAFFORLIDEP, IDBAIXAAFANT, IDBAIXAAFDEP, CDFORMPGTANT,
             CDFORMPGTDEP, DSINCONAFANT, DSINCONAFDEP, IDOPERACLAF,  DSRDMUSULAF,  DSENDUSULAF,
             DSNMUSULAF,   DSMETUSULAF,  CDOPERLOGAF,  DTOPERALAF)
            VALUES
            (@V_CDFILDEST, @V_CDFILLANC, @V_NRAUTOFORN, 0, @V_VRTOTALAF, @V_OLD_IDSITUATUAAF,
             @V_NEW_IDSITUATUAAF, @V_OLD_IDAFFORALIM, @V_NEW_IDAFFORALIM, @V_OLD_IDBAIXAAF, @V_NEW_IDBAIXAAF, @V_OLD_CDFORMPGTO,
             @V_NEW_CDFORMPGTO, @V_OLD_DSINCONSAF, @V_NEW_DSINCONSAF, 'A', @V_DSRDMUSULAF, @V_DSENDUSULAF,
             @V_DSNMUSULAF, @V_DSMETUSULAF, @V_CDOPERLOGAF, GETDATE());

         END;

      END;

      IF @V_IDCOMANDO = 'D' /* DELETING */ BEGIN

         IF SUBSTRING(@V_IDGRAVLOGAF, 3, 1) = 'S' BEGIN

            INSERT INTO LOGAUTOFORNE
            (CDFILDESLAF,  CDFILLANLAF,  NRAUTFORLAF,  VRTOTALAFANT, VRTOTALAFDEP, IDSITUAAFANT,
             IDSITUAAFDEP, IDAFFORLIANT, IDAFFORLIDEP, IDBAIXAAFANT, IDBAIXAAFDEP, CDFORMPGTANT,
             CDFORMPGTDEP, DSINCONAFANT, DSINCONAFDEP, IDOPERACLAF,  DSRDMUSULAF,  DSENDUSULAF,
             DSNMUSULAF,   DSMETUSULAF,  CDOPERLOGAF,  DTOPERALAF)
            VALUES
            (@V_CDFILDEST, @V_CDFILLANC, @V_NRAUTOFORN, 0, @V_VRTOTALAF, @V_OLD_IDSITUATUAAF,
             @V_OLD_IDSITUATUAAF, @V_OLD_IDAFFORALIM, @V_OLD_IDAFFORALIM, @V_OLD_IDBAIXAAF, @V_OLD_IDBAIXAAF, @V_OLD_CDFORMPGTO,
             @V_OLD_CDFORMPGTO, @V_OLD_DSINCONSAF, @V_OLD_DSINCONSAF, 'E', @V_DSRDMUSULAF, @V_DSENDUSULAF,
             @V_DSNMUSULAF, @V_DSMETUSULAF, @V_CDOPERLOGAF, GETDATE());

         END;

      END;
      
      FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                   @V_CDFILDEST,
                                   @V_CDFILLANC,
                                   @V_NRAUTOFORN,
                                   @V_VRTOTALAF,
                                   @V_OLD_IDSITUATUAAF,
                                   @V_NEW_IDSITUATUAAF,
                                   @V_OLD_IDAFFORALIM,
                                   @V_NEW_IDAFFORALIM,
                                   @V_OLD_IDBAIXAAF,
                                   @V_NEW_IDBAIXAAF,
                                   @V_OLD_CDFORMPGTO,
                                   @V_NEW_CDFORMPGTO;
   END;
   
   CLOSE C_DADOS;
   DEALLOCATE C_DADOS;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GRAVA_LOGAUTOFORNE','4.05.127';
GO

