/* Sistemas Integrados TEKNISA

Nome: 8820_SUPTRGS.sql

Descrio:
Trigger para incluso de todas as filiais na
tabela REFORFIL para o fornecedor que estiver sendo inserido.

Com essa trigger, ao incluir um fornecedor, automaticamente o sistema ir
considerar que o mesmo no atende a nenhuma filial.

Criao:
07/12/2004 Marcelo Alexsandro Souza Silva
*/

IF EXISTS (SELECT
              NAME
           FROM
              SYSOBJECTS
           WHERE
              NAME = 'GRAVA_REFORFIL_FORNECEDOR' AND
              TYPE = 'TR')
   DROP TRIGGER GRAVA_REFORFIL_FORNECEDOR
GO

CREATE TRIGGER GRAVA_REFORFIL_FORNECEDOR
ON FORNECEDOR
FOR INSERT

AS

DECLARE @V_NEW_CDFORNECED VARCHAR(21);

BEGIN
   DECLARE C_INSERTED CURSOR FOR
      SELECT
         CDFORNECED
      FROM
         INSERTED;

   OPEN C_INSERTED;

   FETCH NEXT FROM C_INSERTED INTO @V_NEW_CDFORNECED;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      INSERT INTO REFORFIL
         (CDFILIAL,
          CDFORNECED)
      (SELECT
          CDFILIAL,
          @V_NEW_CDFORNECED
       FROM
          FILIAL);
      FETCH NEXT FROM C_INSERTED INTO @V_NEW_CDFORNECED;
   END;

   CLOSE C_INSERTED;
   DEALLOCATE C_INSERTED;
END;
GO
